=== debian/changelog ===
seqan3 (3.2.0+ds-6+deb12u1) bookworm; urgency=medium

  * Team upload.
  * Fix parallel tests. Closes: #1087373.

 -- Santiago Vila <sanvila@debian.org>  Mon, 30 Dec 2024 18:20:00 +0100

seqan3 (3.2.0+ds-6) unstable; urgency=medium

  * Team upload.
  * Fix watch file

 -- Andreas Tille <tille@debian.org>  Mon, 05 Dec 2022 17:47:29 +0100

seqan3 (3.2.0+ds-5) unstable; urgency=medium

  * debian/install: install seqan3 test headers in /usr/include/seqan3/test
    not /usr/include/seqan3/test/test

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Oct 2022 17:21:11 +0200

seqan3 (3.2.0+ds-4) unstable; urgency=medium

  * debian/patches/doxygen_reproducible: Try harder
  * debian/rules: fix the docs-only build ("nocheck" profile)
  * debian/install: include the seqan3 test headers in the distribution
  * debian/patches/newer_gtest.patch: cherry-picked from upstream, retired
    our nullopt.patch

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Oct 2022 14:56:37 +0200

seqan3 (3.2.0+ds-3) unstable; urgency=medium

  * Team upload.
  * Drop unnecessary dependency on build-essential.
  * Work around gcc 12.1 bug
    Closes: #1020035

 -- Andreas Tille <tille@debian.org>  Wed, 28 Sep 2022 08:19:35 +0200

seqan3 (3.2.0+ds-2) unstable; urgency=medium

  * Team upload.

  [ Mattias Ellert ]
  * Add nullopt.patch: fix ftbfs with googletest 1.12 (Closes: #1014582)

  [ Étienne Mollier ]
  * d/README.Debian: fix typo caught by lintian.

 -- Étienne Mollier <emollier@debian.org>  Sat, 09 Jul 2022 14:48:54 +0200

seqan3 (3.2.0+ds-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 20 Jun 2022 16:19:56 +0200
