=== debian/watch ===
version=4
opts="repacksuffix=+ds,dversionmangle=auto,uversionmangle=s/-rc/~rc/,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/seqan/seqan3/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
